package rocks.zipcode;

import com.sun.xml.internal.ws.policy.privateutil.PolicyUtils;

import java.io.*;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Stream;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final File file;
    private List<String> lines;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
    }

    @Override
    public void write(String contentToBeWritten) {

        try {
            FileWriter fileWriter = new FileWriter(file);
            fileWriter.write(contentToBeWritten);
            fileWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten){
        String result = "";
       lines = toList();
       lines.set(lineNumber, valueToBeWritten);
       write(result.join("\n", lines));

    }

    @Override
    public String read(Integer lineNumber) {
        return toList().get(lineNumber);
    }

    @Override
    public String read() {
        String result = "";
        try {
               result = new String(Files.readAllBytes(Paths.get(file.getPath())));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString){
        Pattern pattern = Pattern.compile(stringToReplace);
        Matcher matcher = pattern.matcher(read());
        write(matcher.replaceAll(replacementString));
    }

    @Override
    public void overWrite(String content) {
        write(content);
    }

    public List<String> toList() {
        lines = new ArrayList(){};
       try {
         lines = Files.readAllLines(file.toPath());
       } catch (IOException e) {
           e.printStackTrace();
       }
        return lines;
    }

    @Override
    public File getFile() {
        return file;
    }

    @Override
    public String toString() {
        StringBuilder results = new StringBuilder();
        results.append(getFile().toString()).append("{").append(read()).append("}");
        return results.toString();
    }
}